<div
  class="full-width two-cols-form"
  [attr.data-test-element-id]="'custom-field-form'"
  [formGroup]="parentFormGroup"
  sqtmCoreKeyupStopPropagation
>
  @for (customField of customFields; track customField; let i = $index) {
    <div
      [attr.data-test-cuf-label-id]="customField.id"
      class="label"
      [class.label__align_right]="alignLabelRight"
    >
      {{ customField.label }}
    </div>
    <div>
      <ng-container
        *ngTemplateOutlet="
          getLayoutTemplate(customField);
          context: { customField: customField }
        "
      ></ng-container>
      <ng-container
        *ngTemplateOutlet="
          errorsTemplate;
          context: { customField: customField }
        "
      ></ng-container>
    </div>
  }
</div>

<ng-template #txtField let-customField="customField">
  <ng-container [formGroup]="customFieldControls">
    <input
      class="full-width"
      nz-input
      [attr.data-test-cuf-text-input-id]="customField.id"
      type="text"
      [formControlName]="customField.id"
    />
  </ng-container>
</ng-template>

<ng-template #checkboxField let-customField="customField">
  <ng-container [formGroup]="customFieldControls">
    <span
      class="full-width"
      [attr.data-test-cuf-checkbox-input-id]="customField.id"
      nz-checkbox
      [formControlName]="customField.id"
    ></span>
  </ng-container>
</ng-template>

<ng-template #numericField let-customField="customField">
  <ng-container [formGroup]="customFieldControls">
    <nz-input-number
      class="full-width"
      [attr.data-test-cuf-numeric-input-id]="customField.id"
      [formControlName]="customField.id"
    ></nz-input-number>
  </ng-container>
</ng-template>

<ng-template #richTextField let-customField="customField">
  <sqtm-core-rich-text-field
    class="full-width"
    [formGroup]="customFieldControls"
    [fieldName]="customField.id"
    [attr.data-test-cuf-rich-input-id]="customField.id"
  >
  </sqtm-core-rich-text-field>
</ng-template>

<ng-template #dateField let-customField="customField">
  <ng-container [formGroup]="customFieldControls">
    <nz-date-picker
      class="full-width"
      [attr.data-test-cuf-datepicker-input-id]="customField.id"
      [formControlName]="customField.id"
      [nzFormat]="datePickerFormat"
      [nzAllowClear]="customField.optional"
    >
    </nz-date-picker>
  </ng-container>
</ng-template>

<ng-template #tagField let-customField="customField">
  <ng-container [formGroup]="customFieldControls">
    <nz-select
      class="sqtm-core-tags full-width"
      [attr.data-test-cuf-tag-input-id]="customField.id"
      [formControlName]="customField.id"
      nzMode="tags"
    >
      @for (option of getTagFieldOptions(customField); track option) {
        <nz-option
          [nzLabel]="option.label"
          [nzValue]="option.value"
        ></nz-option>
      }
    </nz-select>
  </ng-container>
</ng-template>

<ng-template #dropdownField let-customField="customField">
  <ng-container [formGroup]="customFieldControls">
    <nz-select
      class="full-width"
      [attr.data-test-cuf-dropdown-input-id]="customField.id"
      [formControlName]="customField.id"
      [nzAllowClear]="customField.optional"
      nzShowSearch
    >
      @for (option of getTagFieldOptions(customField); track option.value) {
        <nz-option
          [nzLabel]="option.label"
          [nzValue]="option.value"
        ></nz-option>
      }
    </nz-select>
  </ng-container>
</ng-template>

<ng-template #errorsTemplate let-customField="customField">
  @for (error of getErrors(customField); track error) {
    <div
      [attr.data-test-cuf-id-error]="customField.id"
      [attr.data-test-error-key]="error.provideI18nKey()"
      class="has-error"
    >
      <span class="sqtm-core-error-message">{{
        error.provideI18nKey() | translate
      }}</span>
    </div>
  }
</ng-template>
